package main

import(
	"os"
	"bufio"
	"github.com/francoispqt/gojay"
	"log"
)

type NestedObject struct{
	something string
}

func (d *NestedObject) UnmarshalJSONObject(dec *gojay.Decoder, key string) error {
    switch key {
    case "something":
        return dec.String(&d.something)
		}
    return nil
}

func (d *NestedObject) NKeys() int {
	return 1
}

type Test struct{
	test string
	data NestedObject
}

func (t *Test) UnmarshalJSONObject(dec *gojay.Decoder, key string) error {
    switch key {
    case "test":
        return dec.String(&t.test)
    case "data":
        return dec.DecodeObject(&t.data)
		}
    return nil
}

func (o *Test) NKeys() int {
    return 2
}

func main() {
	f, err := os.Open("./test.json")
	if err != nil {
		panic(err)
	}
	defer f.Close()

	obj := Test{}
	dec := gojay.NewDecoder(bufio.NewReader(f))
	defer dec.Release()
	if err := dec.DecodeObject(&obj); err != nil {
	    log.Fatal(err)
	}
}
